Wallets

Understanding Wallets

As a stablecoin banking API, we provide the ability to instantly create stablecoin wallets and custody stablecoins in a simple way – without requiring external integrations.

Our wallet module lets customers store stablecoin balances and integrates seamlessly with our payment flows for fiat pay-ins and payouts, enabling fast, cost-effective, and reliable cross-border payment processing.

To create a wallet, you must first create a Customer.

Supported Blockchains and Stablecoins

Blockchain network

Stablecoins

Solana

USDC

Ethereum

USDC, USDT

Polygon

USDC, USDT

Tron

USDT

When interacting with Ethereum L1 and Ethereum L2 – like Ethereum network and Polygon network – note that the wallet addresses are identical.


How to create a Wallet

POST v1/customers/{customer_id}/wallets

This endpoint creates a wallet address associated with a customer. You can create multiple wallet addresses for each customer across supported blockchains.

In the request body, specify both the wallet name and the target blockchain network.

API example

Here's a request example for creating a wallet in solana:

curl <https://api.unblockpay.com/v1/customers/{customer_id}/wallets>
  --request POST
  --header 'Content-Type: application/json'
  --header 'Authorization: YOUR_SECRET_TOKEN'
  --data '{
    "name": "Satoshi wallet",
    "blockchain": "solana"
  }'

Here's a response example:

{
    "id": "0196cc5a-3e53-700d-9fef-6ba253d9fb32",
    "name": "Satoshi wallet",
    "blockchain": "solana",
    "address": "79jRumnFHUAf4wkutTq7231bFYJ494hUqhtJyLqS55fg",
    "customer_id": "0196cc56-04f2-721e-ab93-275ee2efb7ca",
    "partner_id": "238b9770-033b-11f0-9566-118181d0afda",
    "created_at": "2025-05-14T01:13:09.276Z",
    "updated_at": "2025-05-14T01:13:09.276Z"
}

Here's a request example for listing all wallets from a specific customer:

[
    {
        "id": "0197e6b8-9ffd-75c5-a782-52875b8acb7f",
        "name": "Test Account 1",
        "blockchain": "solana",
        "address": "EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v",
        "customer_id": "0196efed-3bfa-71ea-ae05-d9a4b33e361a",
        "partner_id": "b30578dc-20a4-4332-9eac-4643dc4ebbf0",
        "created_at": "2025-07-07T21:09:08.733Z",
        "updated_at": "2025-07-07T21:09:08.733Z"
    },
    {
        "id": "0197e6b8-91ad-72e5-9369-7d202c1eb132",
        "name": "Test Account 2",
        "blockchain": "solana",
        "address": "EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v",
        "customer_id": "0196efed-3bfa-71ea-ae05-d9a4b33e361a",
        "partner_id": "b30578dc-20a4-4332-9eac-4643dc4ebbf0",
        "created_at": "2025-07-07T21:09:05.070Z",
        "updated_at": "2025-07-07T21:09:05.070Z"
    },
    {
        "id": "0196eff1-ba52-73e0-82a8-e81363ab93d4",
        "name": "Test Account 3",
        "blockchain": "solana",
        "address": "EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v",
        "customer_id": "0196efed-3bfa-71ea-ae05-d9a4b33e361a",
        "partner_id": "b30578dc-20a4-4332-9eac-4643dc4ebbf0",
        "created_at": "2025-05-20T23:05:18.674Z",
        "updated_at": "2025-05-20T23:05:18.674Z"
    }
]

Here's a request example for getting the balance in a specific wallet in ethereum:

{
    "wallet_id": "0196f36f-8a12-7049-8093-dc2e2ab6ceea",
    "customer_id": "0196f367-58e0-74f2-8918-4ab67461a65e",
    "blockchain": "ethereum",
    "total_balnce": 0,
    "balances": [
        {
            "currency": "USDT",
            "balance": 0
        },
        {
            "currency": "USDC",
            "balance": 0
        }
    ]
}

Wallets API endpoints

Here are the endpoints you'll need to create, list and manage wallets:

  • POST /v1/customers/{customer_id}/wallets — Create a new wallet

  • GET /v1/customers/{customer_id}/wallets — List all wallets for a customer

  • GET /v1/customers/{customer_id}/wallets/{wallet_id} — Get details for a specific wallet

  • GET /v1/customers/{customer_id}/wallets/{wallet_id}/balance — Get the balance of a specific wallet

For the full schema and request/response details, see the API Reference.